'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _plugins = require('./plugins');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**************************************************
 * Created by nanyuantingfeng on 23/08/2017 17:19.
 **************************************************/
function defaultTo(a, b) {
  return a ? a : b;
}

var DEFAULT_PORT = 8080;
var DEFAULT_HOST = '127.0.0.1';

function parseProxyWithOptions(proxy, options) {
  var oo = {};
  var keys = (0, _keys2.default)(proxy);
  keys.forEach(function (key) {
    var target = proxy[key];
    if (typeof target === 'string') {
      oo[key] = (0, _extends3.default)({ target: target }, options);
    } else {
      oo[key] = (0, _extends3.default)({}, target, options);
    }
  });
  return oo;
}

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(context, next) {
    var devServer, _context$browserSyncO, browserSyncOptions, proxy, proxyOptions, plugins, _context$webpackConfi, host, port;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.devServer = {};
            context.proxy = {};
            context.proxyOptions = { changeOrigin: true };

            next();

            devServer = context.devServer, _context$browserSyncO = context.browserSyncOptions, browserSyncOptions = _context$browserSyncO === void 0 ? false : _context$browserSyncO, proxy = context.proxy, proxyOptions = context.proxyOptions, plugins = context.plugins;
            _context$webpackConfi = context.webpackConfig.devServer = context.devServer = devServer = (0, _extends3.default)({
              hot: true,
              hotOnly: true,
              contentBase: false,
              inline: true,
              noInfo: false,
              host: DEFAULT_HOST,
              port: context.port || DEFAULT_PORT,
              historyApiFallback: true,
              overlay: true,
              proxy: parseProxyWithOptions(proxy, proxyOptions)
            }, devServer), host = _context$webpackConfi.host, port = _context$webpackConfi.port;


            devServer.port = port = port === DEFAULT_PORT ? defaultTo(context.port, port) : defaultTo(port, context.port);

            plugins.push.apply(plugins, [new _plugins.HotModuleReplacementPlugin(), new _plugins.NamedModulesPlugin()]);

            if (browserSyncOptions !== false) {
              plugins.push(new _plugins.BrowserSyncPlugin((0, _extends3.default)({
                host: host,
                port: port + 1,
                proxy: (0, _util.createDomain)(devServer),
                open: false
              }, browserSyncOptions), { reload: true }));
            }

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports['default'];